 function [] = psnrTest()
    % =====================================================================
    % File name   : psnrimg.m
    % File Type   : m-file (script file for Matlab)
    % Requirements: Matlab Image Processing Toolbox
    % Begin       : 2006-07-07
    % Last Update :
    % Author      : Nicola Asuni and Andrea Giachetti
    % Description : Example script for icbi.m testing
    % Copyright   : Andrea Giachetti and Nicola Asuni 
    %                    
    % License     : GNU GENERAL PUBLIC LICENSE v.2
    %               http://www.gnu.org/copyleft/gpl.html
    % =====================================================================
		
	for ZK = 1:1:2
        ZF = 2^ZK;
		fprintf('\n\nZF = %03d\n\n', ZF);
        
		    SPSNRIC = 0;
            SPSNRFC = 0;
          
            
        for i = 1:1:25
				
            % initialize values
            PSNRIC = 0;
            PSNRFC = 0;
           
            zfnum = num2str(ZF, '%1d');
            imnum = num2str(i, '%03d');
					    
            r=512; c=512;
            n = (r-100) * (c-100);
            if ZK == 1
            IMC = imread(strcat('TEST_IMAGES/bw_',imnum,'_512x512_CMP2.TIF'));           
            else
            IMC = imread(strcat('TEST_IMAGES/bw_',imnum,'_512x512_CMP4.TIF')); 
            end
		    % crop out a 50 pixel border
		    IMC = IMC(51:r-50,51:c-50);
		    IMC = double(IMC);
	
            IMB = imread(strcat('TEST_RESULTS/bw_',imnum,'_',zfnum,'X_ICBI.TIF'));
		    IMB = IMB(51:r-50,51:c-50);
		    IMERR = IMC - double(IMB);
		    MSE = sum(sum(IMERR.^2)) / n; % mean squared error 
			RMSE = sqrt(MSE); %  root mean squared error (RMSE) is the square root of MSE
			if (RMSE > 0)
                PSNRIC = 20*log10(255/RMSE); %peak signal-to-noise ratio
                SPSNRIC = SPSNRIC + PSNRIC/25.0;
            end
            
            IMB = imread(strcat('TEST_RESULTS/bw_',imnum,'_',zfnum,'X_FCBI.TIF'));
		    IMB = IMB(51:r-50,51:c-50);
		    IMERR = IMC - double(IMB);
		    MSE = sum(sum(IMERR.^2)) / n; % mean squared error 
			RMSE = sqrt(MSE); %  root mean squared error (RMSE) is the square root of MSE
			if (RMSE > 0)
                PSNRFC = 20*log10(255/RMSE); %peak signal-to-noise ratio
                SPSNRFC = SPSNRFC + PSNRFC/25.0;
            end

     
		    fprintf('%5.3f %5.3f \n', PSNRFC, PSNRIC);
            fprintf('\n');  
	    end
   
    fprintf('AVG ');
    fprintf('%5.3f %5.3f \n', SPSNRFC, SPSNRIC);
	fprintf('\n');  
     end
% === EOF =================================================================
