function [] = testICBI()
% =====================================================================
% File name   : testICBI.m
% File Type   : m-file (script file for Matlab or Octave)
% Last Update : 2008-01-18
% Author      : Andrea Giachetti and Nicola Asuni
% Copyright   : 
% 
% License     : GNU GENERAL PUBLIC LICENSE v.2
%               http://www.gnu.org/copyleft/gpl.html
% =====================================================================

% DESCRIPTION
% --------------------
%

% Help
disp('No help available.');
fid = fopen('TEST_RESULTS/time.txt','wt');

% --- end set parameters ---
for ZK =1:2

    ZF = 2^ZK;
    zfnum = num2str(ZF, '%1d');


    ticbi = 0;
    tfcbi = 0;

    for i = 1:1:25
        imnum = num2str(i, '%03d');
        if ZK == 1
            IM = imread(strcat('TEST_IMAGES/bw_',imnum,'_256x256.TIF'));
        elseif ZK == 2
            IM = imread(strcat('TEST_IMAGES/bw_',imnum,'_128x128.TIF'));
        end

        t1 = cputime;
        [EI] = icbi(IM, ZK);
        ticbi = ticbi+cputime-t1;
        fprintf('ticbi %8.3f sec\t', ticbi);
        imwrite(EI,strcat('TEST_RESULTS/bw_',imnum,'_',zfnum,'X_ICBI.TIF'),'TIF');

        t1 = cputime;
        [EI] = icbi(IM, ZK, 8, 1, false, 0);
        tfcbi = tfcbi+cputime-t1;
        fprintf('tfcbi %8.3f sec\n', tfcbi);
        imwrite(EI,strcat('TEST_RESULTS/bw_',imnum,'_',zfnum,'X_FCBI.TIF'),'TIF');
    end

    fprintf(fid,'TICBI     TFCBI\n');
    fprintf(fid,'%8.3f %8.3f\n',ticbi/25,tfcbi/25);

end

fclose(fid);
% === EOF =================================================================
